package at.jku.students.map;

import at.jku.ssw.Iterator;
import at.jku.ssw.list.impl.LinkedList;
import at.jku.ssw.map.PairList;
import at.jku.ssw.map.HashMapUtil;
import at.jku.ssw.map.Map;
import at.jku.ssw.map.MapIterator;
import at.jku.ssw.map.Pair;

/**
 * An implementation of the {@linkplain Map} class based on the
 * {@linkplain Object#hashCode()} of the key objects that uses separate chaining
 * as its collision strategy.
 */
public final class HashMapSeparateChaining extends Map {

	protected final int tabSize;
	protected PairList[] table;
	private int size;

	public HashMapSeparateChaining(int size) {
		this.tabSize = size;
		table = new PairList[tabSize];
	}

	private int hash(Object val) {
		return HashMapUtil.mod(val.hashCode(), tabSize);
	}

	@Override
	public boolean containsKey(Object key) {
		// TODO
		return false;
	}

	@Override
	public Object get(Object key) {
		// TODO
		return null;
	}

	@Override
	public void put(Object key, Object value) {
		// TODO
	}

	@Override
	public Object remove(Object key) {
		// TODO
		return null;
	}

	@Override
	public int size() {
		// TODO
		return -1;
	}

	@Override
	public Iterator iterator() {
		LinkedList l = new LinkedList();
		for (int i = 0; i < tabSize; i++) {
			PairList e = table[i];
			// special also go through linear list
			if (e != null) {
				while (e != null) {
					l.insert(l.size(), new Pair(e.key, e.value));
					e = e.next;
				}
			}
		}
		return new MapIterator(l);
	}

}
